'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: c_006_.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:00 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************************************
'*
'* owner : peter.junge@sun.com
'*
'* short description : Check the toolbar resources for menu item Tools
'*
'\***********************************************************************************************
'*
' #1 C_006_ ' Initial routine
' #1 tToolsSpellcheck
' #1 tToolsSpellcheckAutomatic
' #1 tToolsThesaurus
' #1 tToolsAutocorrection
' #1 tToolsTracePrecedents
' #1 tToolsRemovePrecedents
' #1 tToolsTraceDependents
' #1 tToolsRemoveDependents
' #1 tToolsRemoveAllTraces
' #1 tToolsTraceError
' #1 tToolsGoalSeek
' #1 tToolsScenarios
' #1 tToolsProtectDocumentTable
' #1 tToolsProtectDocumentDocument
' #1 tToolsAutomaticCalculate
' #1 tToolsNeuCalculate
' #1 tToolsAutoInput
' #1 tToolsMacro
' #1 tToolsConfigure
'*
'\***********************************************************************************************

sub C_006_

   printLog Chr(13) + "--------- C_006_ ---------"
   Call tToolsSpellcheck
   Call tToolsSpellcheckAutomatic
   Call tToolsThesaurus
   Call tToolsAutocorrection
   Call tToolsTracePrecedents
   Call tToolsRemovePrecedents
   Call tToolsTraceDependents
   Call tToolsRemoveDependents
   Call tToolsRemoveAllTraces
   Call tToolsTraceError
   Call tToolsGoalSeek
   Call tToolsScenarios
   Call tToolsProtectDocumentTable
   Call tToolsProtectDocumentDocument
   Call tToolsAutomaticCalculate
   Call tToolsNeuCalculate
   Call tToolsAutoInput
   Call tToolsMacro
   Call tToolsConfigure

End Sub

'
'-----------------------------------------------------
'
testcase tToolsSpellcheck

	if left(iSprache,1) <> 8 then
        Call hNewDocument
        DocumentCalc.TypeKeys "<Right>unnown<Return><Up>"
        ToolsSpellcheckCheckCalc
        Kontext "Rechtschreibung"
        DialogTest ( Rechtschreibung )
        Rechtschreibung.Close
        Call hCloseDocument
 	else
 		printlog "Spellcheck isn't possible for asian languages at this time"
 	end if

endcase
'
'-----------------------------------------------------
'
testcase tToolsSpellcheckAutomatic

  	Call hNewDocument
    ToolsSpellcheckAutoSpellcheck
    DocumentCalc.TypeKeys "<Right>unnown<Return><Up>"
    wait 2000
    ToolsSpellcheckAutoSpellcheck
    Call hCloseDocument

endcase
'
'-----------------------------------------------------
'
testcase tToolsThesaurus

	if iSprache = 48 or iSprache = 07 then
      	printlog "For the language " & iSprache & " is no thesaurus available!"
    end if
    Call hNewDocument
    DocumentCalc.TypeKeys "Test<Return><Up>"
    try
    	ToolsThesaurusCalc
      	Kontext "Thesaurus"
      	DialogTest ( Thesaurus )
      	Sprache.Click

      	Kontext "SpracheAuswaehlen"
      	DialogTest ( SpracheAuswaehlen )
      	SpracheAuswaehlen.Cancel

      	Kontext "Thesaurus"
      	Thesaurus.Cancel
    catch
    	if iSprache > 80 then
    		printlog "There is no thesaurus for asian langauges available"
    	else
    		warnlog "No thesaurus available, could be bugID:81520!"
    	end if
    endcatch
    Call hCloseDocument

endcase
'
'-----------------------------------------------------
'
testcase tToolsAutocorrection

  	Call hNewDocument

    ToolsAutocorrect
    try
    	kontext "Active"
    	if Active.exists then
    		active.ok
    		warnlog "It seems that bug:90025 is still present"
    	end if
    catch
    endcatch

    Kontext
    active.SetPage TabOptionen
    Kontext "TabOptionen"
    Call DialogTest ( TabOptionen )

    Kontext
    active.SetPage TabErsetzung
    Kontext "TabErsetzung"
    Call DialogTest ( TabErsetzung )

    Kontext
    active.SetPage TabAusnahmen
    Kontext "TabAusnahmen"
    Call DialogTest ( TabAusnahmen )
    Abkuerzungen.settext "Lala"
    AbkuerzungenNeu.click
    AbkuerzungenLoeschen.click
    Woerter.settext "LALA"
    WoerterNeu.click
    WoerterLoeschen.click

    Kontext
    active.SetPage TabTypografisch

    Kontext "TabTypografisch"
    EinfachWortAnfang.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 1 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    EinfachWortEnde.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 2 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    EinfachStandard.Click

    Kontext "TabTypografisch"
    DoppeltWortAnfang.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 3 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    DoppeltWortEnde.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 4 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    DoppeltStandard.Click
    TabTypografisch.cancel

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsTracePrecedents

    Call  hNewDocument
    DocumentCalc.Typekeys "<Right>=A1<Return><Up>"
    ToolsDetectiveTracePrecedents
    ToolsDetectiveRemovePrecedents
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsRemovePrecedents

    Call  hNewDocument
    DocumentCalc.Typekeys "<Right>=A1<Return><Up>"
    ToolsDetectiveTracePrecedents
    ToolsDetectiveRemovePrecedents
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsTraceDependents

    Call  hNewDocument
    DocumentCalc.Typekeys "<Right>=A1<Return><Up><Left>"
    ToolsDetectiveTraceDependents
    ToolsDetectiveRemoveDependents
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsRemoveDependents

    Call  hNewDocument
    DocumentCalc.Typekeys "<Right>=A1<Return><Up><Left>"
    ToolsDetectiveTraceDependents
    ToolsDetectiveRemoveDependents
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsRemoveAllTraces

    Call  hNewDocument
    DocumentCalc.Typekeys "<Right>=A1<Return><Up>"
    ToolsDetectiveTracePrecedents
    DocumentCalc.Typekeys "<Right>=B1<Return><Up><Left>"
    ToolsDetectiveTraceDependents
    ToolsDetectiveRemoveAllTraces
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
' a marked formula is required
testcase tToolsTraceError

    Call  hNewDocument
    Kontext
    DocumentCalc.Typekeys "=A2/A3<Return><Up>"
    ToolsDetectiveTraceError
    ToolsDetectiveRemoveAllTraces
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsDetectiveMarkInvalidData

      Call  hNewDocument
      ToolsDetectiveMarkInvalidData
      ToolsDetectiveRemoveAllTraces
      Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsDetectiveFuellModus

    Call  hNewDocument
    ToolsDetectiveFillMode
    DocumentCalc.Typekeys "<Right>"
    ToolsDetectiveFillMode
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsGoalSeek

    Call  hNewDocument
    ToolsGoalSeek
    Kontext "Zielwertsuche"
    DialogTest ( Zielwertsuche )
    Zielwertsuche.Cancel
    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsScenarios

    Call  hNewDocument
    DocumentCalc.Typekeys "1<Return>2<Return><Up><Up>"
    Call ZellenMarkieren ( 2, 1 )
    ToolsScenarios
    Kontext "SzenarioAnlegen"
    DialogTest ( SzenarioAnlegen )
    SzenarioAnlegen.Ok
    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsProtectDocumentTable

    Call  hNewDocument
    ToolsProtectDocumentSheet
    Kontext "TabelleSchuetzen"
    DialogTest2 ( TabelleSchuetzen,1 )
    Passwort.SetText "wwwww"
    Bestaetigung.SetText ""
    TabelleSchuetzen.Ok

    Kontext "Active"
    if Active.Exists then
    	Active.OK
    else
    	warnlog "There wasn't reported any error by confirming a wrong password!"
    end if

    Kontext "TabelleSchuetzen"
    Bestaetigung.SetText "wwwww"
    TabelleSchuetzen.Ok

    ToolsProtectDocumentSheet
    Kontext "TabelleSchuetzen"
    DialogTest2 ( TabelleSchuetzen,3 )
    Passwort.setText "wwwww"
    TabelleSchuetzen.Ok

    ToolsProtectDocumentSheet
    Kontext "TabelleSchuetzen"
    TabelleSchuetzen.Cancel

    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsProtectDocumentDocument

    Call  hNewDocument

    ToolsProtectDocumentDocument
    Kontext "DokumentSchuetzen"
    DialogTest2 ( DokumentSchuetzen,4 ) 'Id gleich tabelle schuetzen
    Passwort.setText "wwwww"
    Bestaetigung.SetText ""
    DokumentSchuetzen.ok

    Kontext "Active"
    if Active.Exists then
       Active.OK
    else
       warnlog "There wasn't reported any error by confirming a wrong password!"
    end if

    Kontext "DokumentSchuetzen"
    Bestaetigung.SetText "wwwww"
    DokumentSchuetzen.ok

    ToolsProtectDocumentDocument
    Kontext "DokumentSchuetzen"
    DialogTest2 ( DokumentSchuetzen,6 )
    Passwort.setText "wwwww"
    DokumentSchuetzen.ok

    ToolsProtectDocumentDocument
    Kontext "DokumentSchuetzen"
    DokumentSchuetzen.Cancel

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsAutomaticCalculate

    Call  hNewDocument
    ToolsCellContentsAutoCalculate
    ToolsCellContentsAutoCalculate
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsNeuCalculate

    Call  hNewDocument
    ToolsCellContentsAutoCalculate
    Wait 100
    ToolsCellContentsRecalculate
    Wait 100
    ToolsCellContentsAutoCalculate
    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsAutoInput

    Call  hNewDocument
    ToolsCellContentsAutoInput
    ToolsCellContentsAutoInput
    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsMacro

    Call hNewDocument
    dim flag as boolean
    flag = true
    ToolsMacro

    Printlog "Testing Macro dialog"
    Kontext "Makro"
    Call DialogTest ( Makro )
    
    try
    	Verwalten.Click
    catch
    	warnlog "Button Organizer is disabled"
    	flag = false
    endcatch

    if flag = true then
        printlog "+ Testing Organizer - Modules Tabpage"
    	Kontext
    	active.SetPage TabModule
    	Kontext "TabModule"
    	Call DialogTest ( TabModule )

    	printlog "+ Testing Organizer - Libraries Tabpage"
	Kontext
    	active.SetPage TabBibliotheken
    	Kontext "TabBibliotheken"
    	Call DialogTest ( TabBibliotheken )
    	try
    		Hinzufuegen.Click
    	catch
    	    warnlog "The button 'Append' is disabled."
    	endcatch
    	try
    		printlog "+ Testing Organizer - Libries/Append (File Open dialog should appear)"
		Kontext "OeffnenDlg"
    		OeffnenDlg.Cancel
    	catch
    		warnlog "Looks like the file open dialog didn't came up"
    	endcatch
    	Kontext "TabBibliotheken"
    	TabBibliotheken.close
    end if
    Kontext "Makro"
    Makro.Cancel
    call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsConfigure

    call hNewDocument
    Kontext
    DocumentCalc.mousemove 1,1
    ToolsConfigure

    Kontext
    active.SetPage TabTastatur
    Kontext "TabTastatur"
    Call DialogTest ( TabTastatur )
    printlog "  TabTastatur"

    Kontext
    active.SetPage TabStatusleiste
    Kontext "TabStatusleiste"
    Call DialogTest ( TabStatusleiste )
    printlog "  TabStatusleiste"

    Kontext
    active.SetPage TabSymbolleisten
    Kontext "TabSymbolleisten"
    Call DialogTest ( TabSymbolleisten )
    printlog "  TabSymbolleiste"

    Kontext
    active.SetPage TabMenu
    Kontext "TabMenu"
    Call DialogTest ( TabMenu )
    printlog "  TabMenü"

    Kontext
    active.SetPage TabEreignisse
    Kontext "TabEreignisse"
    Call DialogTest ( TabEreignisse )
    printlog "  TabEreignisse"

    Kontext
    active.SetPage TabSymbolleisten
    Kontext "TabSymbolleisten"
    Call DialogTest ( TabSymbolleisten )
    Bearbeiten.Click

    Kontext "CustomizeToolbars"
    Call DialogTest ( CustomizeToolbars )
    printlog "  CustomizeToolbars"
    CustomizeToolbars.Close

    call hCloseDocument

endcase
'
'------------------------------------------------------------
