'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: t_lists.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:39 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*
'* owner : thorsten.ziehm@sun.com
'*
'* short description : general routines to work with lists ( arrays )
'*
'*******************************************************************
'* general information :
'* - entry 0 of the list is the counter
'* - you have to start loops everytime with 1 .. n
'*
' #1 ListCount           ' return the number of list entries
' #1 ListCopy            ' copy one list to another ( OrgList(), CopyList() )
' #1 ListAllDelete       ' delete the complete list
' #1 ListInsert          ' insert a string into a list at a special number
' #1 ListAppend          ' append an entry to a list
' #1 ListDelete          ' delete the n'th entry out of the list ( lsList(), EntryNumber  )
' #1 ListDeleteString    ' delete a string out of the list ( the first found string )
' #1 ListSort            ' sort a list with Quicksort-Method, if the 2. parameter is FALSE => downward, else => upward
'*
' #1 ListRead            ' read a file into a list ( row for row )
' #1 ListReadAppend      ' read a file into a list and append it onto another existed list
' #1 ListWrite           ' write a list into a file ( each entry is a row ) => the file will be created new
' #1 ListWriteAppend     ' write a list into a file, but append all entries to the file
'*
'\******************************************************************
' *    TZ  - 09.07.01  insert UFT8-encoding as optional parameter in ListRead and ListReadAppend
' *    TZ  - 01.08.01  activate UFT8-encoding to read List from files
' *    TZ  - 06.08.01  insert UTF8-encoding as optional parameter in ListWrite and ListWriteAppend


'************************************************************
' TZ
function ListCount ( lsList() as String ) as Integer
'///<b> ListCount ( lsListe() as String )</b>
'///+return the number of list entries
'///- input  : the list ( only string lists are possible )
'///+- return : the number of entries

   ListCount =  Val(lsList(0))
end function


'************************************************************
' TZ
function ListCopy ( lsList1() as String, lsList2() as String ) as Boolean
'///<b>ListCount ( lsOrg(), lsCopy() )</b>
'///+copy all entries out of one list into another list
'///- input  : 1. list which should be copied, 2. an empty list => after this function the 2. list is a copy of the 1. list
'///+- return : if copy of the list is correct, this function returns => TRUE else FALSE

  Dim ii as Integer

   ListAllDelete ( lsList2() )
    for ii=1 to ListCount ( lsList1() )
       ListAppend ( lsList2(), lsList1(ii) )
    next ii

    if ListCount ( lsList1() ) = ListCount ( lsList2 () ) then
       ListCopy = TRUE
    else
       ListCopy = FALSE
    end if
end function


'************************************************************
' TZ
sub ListAllDelete ( lsList() as String )
'///<b>ListAllDelete ( lsList() as String )</b>
'///delet the complete list
'///- input  : the list ( only string lists are possible )
'///+- return : - -

    lsList(0) = "0"
end sub


'************************************************************
' TZ
sub ListAppend ( lsList() as String, sNewEntry as String )
'///<b>ListAppend( lsList() as String, NewEntry as String )</b>
'///+append a new entry at the end of the list
'///- input  : 1. the list ( only string lists are possible )    2. the new entry
'///+- return : - -

   lsList(0) = Val(lsList(0)) + 1
   lsList( lsList(0) ) = sNewEntry

end sub


'************************************************************
' TZ
function ListDelete ( lsList() as String, iNr as Integer ) as Boolean
'///<b>ListDelete ( lsList() as String, RowNumber as Integer )</b>
'///+delete an entry out of the list on position iNr
'///- input  : 1. the list ( only string lists are possible )    2. the position of the entry
'///+- return : TRUE if the entry was deleted, else FALSE

  Dim i%, ListenAnzahl as Integer

   ListenAnzahl = Val(lsList(0))
   if iNr > ListenAnzahl then
      ListDelete = FALSE
      Exit Function
   end if

   for i% = iNr to ListenAnzahl
      lsList( i% ) = lsList( i% + 1 )
   next i%

   lsList(0) = ListenAnzahl - 1

   ListDelete = TRUE

end function

'************************************************************
' TZ
function ListDeleteString ( lsList() as String, sText as String ) as Boolean
'///<b>ListDeleteString ( lsList() as String, sText as String )</b>
'///+delete the 1st string in the list which is equal to the input string
'///- input  : 1. the list ( only string lists are possible )    2. the string
'///+- return : TRUE if the entry was deleted, else FALSE

  Dim i as Integer : Dim EintragsNr as Integer : Dim ListenAnzahl as Integer

    ListenAnzahl = Val(lsList(0))
    EintragsNr = 0
    for i = 1 to ListenAnzahl
        if lsList(i) = sText then
           EintragsNr = i
           i = ListenAnzahl + 1
        end if
    next i
    if EintragsNr = 0 then
       ListDeleteString = FALSE
    else
       ListDeleteString = ListDelete ( lsList(), EintragsNr )
    end if
end function

'************************************************************
' TZ
function ListInsert ( lsList() as String, ZeileNr%, sWert$ ) as Boolean
'///ListInsert ( lsList() as String, iNr as Integer, sText as String )
'///+insert a string at a special position in the list
'///- input  : 1. the list ( only string lists are possible )     2. the position       3. the string
'///+- return : TRUE if the entry was inserted, else FALSE
  Dim i% : Dim ListenAnzahl as Integer

    ListenAnzahl = Val(lsList(0))
    if ZeileNr% > ListenAnzahl then
      ListInsert = FALSE
      Exit Function
   end if

    ' Nach hinten verschieben, hinten beginnend
    for i% = ListenAnzahl to ZeileNr% step -1
      lsList( i%+1 ) = lsList( i% )
   next i%

    ' Einfuegen
   lsList( ZeileNr% ) = sWert$
    lsFile(0) = ListenAnzahl + 1
   ListInsert = TRUE

end function

'************************************************************
' TZ
function ListRead ( lsList() as String, Datei$, optional sEncode as String ) as Boolean
'///<b>ListRead( lsList() as String, File as String, optional Endoding as string )</b>
'///+open a file and insert all rows into a list ( row for row )
'///- input : 1. the list ( old list entries will be deleted )     2. the file       3. optional -> the encoding 'UTF8'
'///+- return : TRUE or FALSE if this routine can read the file

  Dim bUTF8 as Boolean
  Dim i%
  Dim CompareList(10000) as String

   if Dir( Datei$ ) = "" then
      Warnlog "ListRead: " + Datei$ + " is missing!"
      ListRead = FALSE
      exit function
   end if

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UFT8" OR UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead :" +  sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   ListAllDelete ( lsList() )                             ' clean up the list

   if bUTF8 =  TRUE then
      Dim textin as object, sfa as object, xInput as object                   ' for UTF-8-input-routines
      Dim iC as Integer

      textin = createUnoService( "com.sun.star.io.TextInputStream" )         '* uno-handling to input an UFT-8-File
      textin.setEncoding("utf8")                                             '*
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '*
      xInput = sfa.openFileRead( Datei$ )                                    '*
      textin.setInputStream( xInput )                                        '*

      do until textin.isEOF()                                                '*
         i% = Val(lsList(0)) + 1
         lsList(0) = i%
         lsList( i% ) = textin.readLine()                                    '*
      loop
      xInput.closeInput                                                      '* uno-file-close

    '(TZ)... only to workaround a problem with UNIX-Files and
      if Right ( lsList(i%), 1 ) = Chr(10) then
         lsList(i%) = Left ( lsList(i%), Len ( lsList(i%) ) - 1 )
      end if
    '...
   else
      Dim FileNum%

      FileNum% = FreeFile
      Open Datei$ for input  as #FileNum%

      do until EOF(#FileNum%) ' alles aus LIS-Datei
         i% = Val(lsList(0)) + 1
         lsList(0) = i%
         Line Input #FileNum%, lsList( i% )
      loop
      Close #FileNum%
   end if
   ListRead = TRUE
end function

'************************************************************
' TZ
function ListWrite ( lsList() as String, Datei$, optional sEncode as String) as Boolean
'///<b>ListWrite ( lsList() as String, file as String, optional Encoding as String ) </b>
'///+write a list into a file ( an existing file will be deleted before )
'///- input : 1. the list        2. the file        3. optional -> the encoding 'UTF8'
'///+- return : TRUE or FALSE if this routine can read the file

  Dim bUTF8 as Boolean
  Dim i%

   if Dir (Datei$) <> "" then Kill(Datei$)                 ' the file must be deleted if you use 'UTF8'

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead :" +  sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   if bUTF8 =  TRUE then
     Dim textout as object, sfa as object, xOutput as object                  ' for UTF-8-output-routines

      textout = createUnoService( "com.sun.star.io.TextOutputStream" )        '* uno-handling to output an UFT-8-File
      textout.setEncoding("utf8")                                             '*
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '*
      xOutput = sfa.openFileWrite( Datei$ )                                  '*
      textout.setOutputStream( xOutput )                                      '*

      for i%=1 to ListCount ( lsList() )
         textout.writeString( lsList( i% ) + Chr(13) + Chr(10) )              '*
      next i%
      xOutput.closeOutput                                                    '* uno-file-close
   else
     Dim FileNum% : Dim iLast%

      FileNum% = FreeFile
      Open Datei$ for Output  as #FileNum%
      iLast% = Val(lsList(0))
      i%=1
      do while i% <= iLast%
         Print #FileNum%, lsList(i%)
           i% = i% +1
      loop
      Close #FileNum%
   endif

   ListWrite = TRUE
end function

'************************************************************
' TZ
function ListReadAppend( lsList() as String , Datei$, optional sEncode as String ) as Boolean
'///<b>ListReadAppend( lsList() as String, file as String, optional Encoding as String ) </b>
'///+append a list into a file ( it the file exists the file will be deleted before )
'///- input : 1. the list        2. the file        3. optional -> the encoding 'UTF8'
'///+- return : TRUE or FALSE if this routine can write the file

  Dim bUTF8 as Boolean
  Dim i%
  Dim CompareList() as String
  Dim isCounter as Integer
  Dim FileNum%

   if Dir( Datei$ ) = "" then
      Warnlog "ListReadAppend : " + Datei$ + " is missing!"
      ListReadAppend = FALSE
      exit function
   end if

   isCounter = ListCount ( lsList() )

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UFT8" OR UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead : " + sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   if bUTF8 =  TRUE then
      Dim textin as object, sfa as object, xInput as object                  '* for UTF-8-input-routines

      textin = createUnoService( "com.sun.star.io.TextInputStream" )         '* uno-handling to input an UFT-8-File
      textin.setEncoding("utf8")                                             '*
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '*
      xInput = sfa.openFileRead( Datei$ )                                    '*
      textin.setInputStream( xInput )                                        '*

      do until textin.isEOF()                                                '*
         i% = Val(lsList(0)) + 1
         lsList(0) = i%
         lsList( i% ) = textin.readLine()                                    '*
      loop
      xInput.closeInput                                                      '* uno-file-close

    '(TZ)... only to workaround a problem with UNIX-Files and
      if Right ( lsList(i%), 1 ) = Chr(10) then
         lsList(i%) = Left ( lsList(i%), Len ( lsList(i%) ) - 1 )
      end if
    '...
   else
      FileNum% = FreeFile
      Open Datei$ for input  as #FileNum%

      do until EOF(FileNum%)                            ' alles aus LIST-Datei
         i% =  Val(lsList(0)) + 1
         lsList(0) = i%
         Line Input #FileNum%, lsList( i% )
      loop
      Close #FileNum%
   end if

   ListReadAppend = TRUE

end function


'************************************************************
' TZ
function ListWriteAppend( lsList() as String, Datei$, optional sEncode as String ) as Boolean
'///<b>ListWrite ( lsList() as String, file as String, optional Encoding as String ) </b>
'///+write a list into a file ( if the files exists all entries will be appended )
'///- input : 1. the list        2. the file        3. optional -> the encoding 'UTF8'
'///+- return : TRUE or FALSE if this routine can read the file

  Dim bUTF8 as Boolean
  Dim i%
  Dim DummyList (5000 ) as String

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead :" +  sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   if bUTF8 =  TRUE then
     Dim sfa as object, xOutput as object, textout as object                 ' for UTF-8-output-routines

      ListRead ( DummyList(), Datei$, "utf8" )                               ' read old file in another list
      for i% = 1 to ListCount ( lsList() )
         ListAppend ( DummyList(), lsList(i%) )                              ' add the new list at the old list
      next i%

      textout = createUnoService( "com.sun.star.io.TextOutputStream" )       '* uno-handling to output an UFT-8-File
      textout.setEncoding("utf8")                                            '*
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '*
      xOutput = sfa.openFileWrite( Datei$ )                              '*
      textout.setOutputStream( xOutput )                                     '*

      for i%=1 to ListCount (DummyList())
         textout.writeString( DummyList( i% ) + Chr(13) + Chr(10 )           '*
      next i%
      xOutput.closeOutput                                                    '* uno-file-close
   else
    Dim FileNum%

     FileNum% = FreeFile
     Open Datei$ for Append  as #FileNum%

     for i% = 1 to Val(lsList(0))
        Print #FileNum%, lsList(i%)
      next i%

      Close #FileNum%
   end if
   ListWriteAppend = TRUE

end function


'************************************************************
' TZ
sub ListSort ( lsList() as String, optional UpDown as Boolean )
'///<b>ListSortUp ( lsListe as String, optional UpDown )</b>
'///+sorted a list upward per default or downward if optional parameter is FALSE with Quicksort-Method
'///- input  : unsorted list; out => sorted list
'///+- return : --

  Dim Listenanzahl as Integer, i as Integer, j as Integer
  Dim Zwischenspeicher as String

   ListenAnzahl = Val(lsList(0))
   for i=ListenAnzahl-1 to 1 step -1
      for j=1 to i
         if UpDown = FALSE then
            if uCase ( lsList(j) ) < uCase ( lsList(j+1) ) then            ' upward sorting
               Zwischenspeicher = lsList (j)                               ' invert value (i) with value (i+1)
               lsList (j) = lsList(j+1)
               lsList (j+1) = Zwischenspeicher
            end if
         else
            if uCase ( lsList(j) ) > uCase ( lsList(j+1) ) then            ' downward sorting
               Zwischenspeicher = lsList (j)                               ' invert value (i) with value (i+1)
               lsList (j) = lsList(j+1)
               lsList (j+1) = Zwischenspeicher
            end if
         end if
      next j
   next i
end sub


'************************************************************
' TZ
sub gCompare2Lists ( ListOne() as String, ListTwo() as String )
'///<b>gCompare2Lists ( ListOne() as String, ListTwo() as String )</b>
'///+compare the 2. list with the 1. list
'///- input  : 1. ListOne => Should-list     2. ListTwo => Is-list
'///+- return : --

   dim lsListErr(1000) as String
   dim i as Integer, j as Integer

   for i=1 to ListCount ( ListOne() )
       for j=1 to ListCount ( ListTwo() )
           if ListOne(i) = ListTwo(j) then

              printlog "in gCompare2Lists: " + ListOne ( i ) + " matched"
              ListDelete ( ListTwo(), j )
              j=1000
           end if
       next j
       if j<1000 then ListAppend ( lsListErr(), ListOne(i) )
   next i

   for i=1 to ListCount ( lsListErr() )
      Warnlog "new  -> : " + lsListErr(i)
   next i

   for i=1 to ListCount ( ListTwo() )
      Warnlog "lost <- : " + ListTwo(i)
   next i

end sub

