'*************************************************************************
'*
'*  $RCSfile: t_option.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:39 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : General option test (sub-routines for options tests)
'*
'************************************************************************
'*
' #1 hToolsOptions       'Select the correct page in Tools / Options
'*
'\***********************************************************************

function hToolsOptions ( Applicationname as string, Tabpagename as string ) as Boolean
  Dim bCorPage as Boolean
  Dim bFirst as Boolean
  Dim AnzahlEintraegeZu as Integer 
  Dim AnzahlEintraege as Integer
  Dim i as Integer
  Dim startpos as integer

'///<i>hToolsOptions</i>: Routine to select the correct option page
'///+<u>input</u>: The groupname as string, name of optionpage as string
'///+<u>note</u>: The options dialog has to be opened

   SetControlType CTTreeListBox

   Kontext "Active"
   try
      if Active.Exists(1) then Active.OK
   catch
      if Active.Exists(1) then Active.No
   endcatch
'///Group names list: 
'///+<ul><li>&quot;StarOffice&quot;</li>
'///+<li>&quot;LoadSave&quot;</li>
'///+<li>&quot;LanguageSettings&quot;</li>
'///+<li>&quot;Internet&quot;</li>
'///+<li>&quot;Textdocument&quot;</li>
'///+<li>&quot;HTMLDocument&quot;</li>
'///+<li>&quot;Spreadsheet&quot;</li>
'///+<li>&quot;Presentation&quot;</li>
'///+<li>&quot;Drawing&quot;</li>
'///+<li>&quot;Formula&quot;</li>
'///+<li>&quot;Chart&quot;</li>
'///+<li>&quot;Datasource&quot;</li></ul>
   Kontext "ExtrasOptionenDlg"
      select case Ucase$(Applicationname)
         case "STAROFFICE"        : startpos = 1
         case "LOADSAVE"          : startpos = 2
         case "LANGUAGESETTINGS"  : startpos = 3
         case "INTERNET"          : startpos = 4
         case "TEXTDOCUMENT"      : startpos = 5
         case "HTMLDOCUMENT"      : startpos = 6
         case "SPREADSHEET"       : startpos = 7
         case "PRESENTATION"      : startpos = 8
         case "DRAWING"           : startpos = 9
         case "FORMULA"           : startpos = 10
         case "CHART"             : startpos = 11
         case "DATASOURCES"       : startpos = 12
         case else                : warnlog "hToolsOptions(): " + Applicationname + " / " + Tabpagename + " could not be found! Please review your testscript!"
                                    exit function
     end select

   if ExtrasOptionenDlg.Exists then
      Optionsliste.TypeKeys "<HOME>"
      for i = 1 to 12+1
         Optionsliste.TypeKeys "-<DOWN>"
      next i
 'Optionsliste.TypeKeys "<HOME>"
      AnzahlEintraegeZu = Optionsliste.GetItemCount
      Optionsliste.select Startpos
      Optionsliste.typekeys "+"
      AnzahlEintraege = Optionsliste.GetItemCount
      bFirst = TRUE
      for i = 1 to AnzahlEintraege - AnzahlEintraegeZu
         bCorPage = FALSE
         Kontext "ExtrasOptionenDlg"
         Optionsliste.TypeKeys "<DOWN>"
         sleep (1)
         select case ucase$(Applicationname)
            case "STAROFFICE"
'///Pages in group &quot;StarOffice&quot;are:
'///+<ul><li>&quot;UserData&quot;</li>
'///+<li>&quot;General&quot;</li>
'///+<li>&quot;Memory&quot;</li>
'///+<li>&quot;View&quot;</li>
'///+<li>&quot;Print&quot;</li>
'///+<li>&quot;ExternalPrograms&quot;</li>
'///+<li>&quot;Paths&quot;</li>
'///+<li>&quot;Colors&quot;</li>
'///+<li>&quot;FontReplacement&quot;</li>
'///+<li>&quot;Security&quot;</li>
'///+<li>&quot;Appearence&quot;</li>
'///+<li>&quot;Accessibility&quot;</li>
'///+<li>&quot;SingleSignon&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "USERDATA"
                              Kontext "TabBenutzerdaten"
                              if TabBenutzerdaten.exists then bCorPage = TRUE
                      case "GENERAL"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabSonstigesAllgemein"
                              If TabSonstigesAllgemein.exists then bCorPage = TRUE
                      case "MEMORY"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabMemory"
                              If TabMemory.exists then bCorPage = TRUE
                      case "VIEW"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabAnsichtAllgemein"
                              If TabAnsichtAllgemein.exists then bCorPage = TRUE
                      case "PRINT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 5 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabPrintStarOffice"
                              if TabPrintStarOffice.exists then bCorPage = TRUE
                      case "EXTERNALPROGRAMS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 6 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabHelperPrograms"
                              If TabHelperPrograms.exists then bCorPage = TRUE
                      case "PATHS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 7 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabPfade"
                              If TabPfade.exists then bCorPage = TRUE
                      case "COLORS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 8 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabFarben"
                              If TabFarben.exists(4) then bCorPage = TRUE
                      case "FONTREPLACEMENT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 9 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabSchriftErsetzung"
                              If TabSchriftErsetzung.exists then bCorPage = TRUE
                      case "SECURITY"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 10 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabScripting"
                              If TabScripting.exists then bCorPage = TRUE
                      case "APPEARANCE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 11 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabAppearance"
                              If TabAppearance.exists then bCorPage = TRUE
                      case "ACCESSIBILITY"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 12 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabAccessibility"
                              If TabAccessibility.exists then bCorPage = TRUE
                      case "SIGNLESIGNON"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 13 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabSingleSignOn"
                              If TabSingleSignOn.exists then bCorPage = TRUE
                      case else :  bCorPage = FALSE
                end select
            case "LOADSAVE"
'///Pages in group &quot;LoadSave&quot;are:           
'///+<ul><li>&quot;General&quot;</li>
'///+<li>&quot;VBAProperties&quot;</li>
'///+<li>&quot;MicrosoftOffice&quot;</li>
'///+<li>&quot;HTMLCompatibility&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "GENERAL"
                              Kontext "TabSpeichern"
                              if TabSpeichern.exists then bCorPage = TRUE
                      case "VBAPROPERTIES"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabMicrosoftOffice97"
                              If WinwordBasicLaden.exists(4) then bCorPage = TRUE
                      case "MICROSOFTOFFICE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabMicrosoftOffice2"
                              If Auswahl.exists(4) then bCorPage = TRUE
                      case "HTMLCOMPATIBILITY"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabHtml"
                              If TabHtml.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                end select
            case "LANGUAGESETTINGS"
'///Pages in group &quot;LanguageSettings&quot;are:
'///+<ul><li>&quot;Language&quot;</li>
'///+<li>&quot;WritingAids&quot;</li>
'///+<li>&quot;SearchingJapanese&quot;</li>
'///+<li>&quot;AsianLayout&quot;</li></ul>
                  Kontext "Active"
                  if Active.Exists then Active.OK
                  Kontext "ExtrasOptionenDlg"
                  select case ucase$(Tabpagename)
                      case "LANGUAGES"
                              sleep (2)
                              Kontext "TabSprachen"
                              If TabSprachen.exists then bCorPage = TRUE
                      case "WRITINGAIDS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (3)
                              bFirst = FALSE
                              Kontext "TabLinguistik"
                              If TabLinguistik.exists then bCorPage = TRUE
                      case "SEARCHINGINJAPANESE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (2)
                              bFirst = FALSE
                              Kontext "TabJapaneseFind"
                              if TabJapaneseFind.exists then bCorPage = TRUE
                      case "ASIANLAYOUT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (2)
                              bFirst = FALSE
                              Kontext "TabAsianLayoutOptions"
                              if TabAsianLayoutOptions.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "INTERNET"
'///Pages in group &quot;Internet&quot;are:            
'///+<ul><li>&quot;Proxy&quot;</li>
'///+<li>&quot;Search&quot;</li></ul>
                  Kontext "Active"
                  if Active.Exists then Active.OK
                  Kontext "ExtrasOptionenDlg"
                  select case ucase$(Tabpagename)
                      case "PROXY"
                              Kontext "ProxyWarnung"
                              if ProxyWarnung.Exists then
                                 NichtMehrAnzeigen.Check
                                 ProxyWarnung.OK
                              end if
                              Kontext "TabProxyServer"
                              sleep (1)
                              if TabProxyServer.exists then bCorPage = TRUE
                      case "SEARCH"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabSuche"
                              If TabSuche.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "TEXTDOCUMENT"
'///Pages in group &quot;TextDocument&quot;are:
'///+<ul><li>&quot;General&quot;</li>
'///+<li>&quot;View&quot;</li>
'///+<li>&quot;FormattinAids&quot;</li>
'///+<li>&quot;Grid&quot;</li>
'///+<li>&quot;BasicFonts&quot;</li>
'///+<li>&quot;BasicFontsAsian&quot;</li>
'///+<li>&quot;BasicFontsCTL&quot;</li>
'///+<li>&quot;Print&quot;</li>
'///+<li>&quot;Table&quot;</li>
'///+<li>&quot;Changes&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "GENERAL"
                              Kontext "TabLaden"
                              If TabLaden.exists then bCorPage = TRUE
                      case "VIEW"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabInhalteWriter"
                              If TabInhalteWriter.exists then bCorPage = TRUE
                      case "FORMATTINGAIDS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabDirektCursor"
                              If TabDirektCursor.exists then bCorPage = TRUE
                      case "GRID"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabRaster"
                              If TabRaster.exists then bCorPage = TRUE
                      case "BASICFONTS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 5 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabGrundschriften"
                              If TabGrundschriften.exists then bCorPage = TRUE
                      case "BASICFONTSASIAN"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 6 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabGrundschriftenASIAN"
                              If TabGrundschriftenASIAN.exists then bCorPage = TRUE
                      case "BASICFONTSCTL"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 6 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabGrundschriftenCTL"
                              If TabGrundschriftenCTL.exists then bCorPage = TRUE
                      case "PRINT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 6 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabDruckenWriter"
                              If TabDruckenWriter.exists then bCorPage = TRUE
                      case "TABLE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 7 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabTabelleOptionen"
                              If TabTabelleOptionen.exists then bCorPage = TRUE
                      case "CHANGES"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 8 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabAenderungenWriter"
                              If TabAenderungenWriter.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "HTMLDOCUMENT"
'///Pages in group &quot;HTMLDocument&quot;are:
'///+<ul><li>&quot;General&quot;</li>
'///+<li>&quot;View&quot;</li>
'///+<li>&quot;Grid&quot;</li>
'///+<li>&quot;Print&quot;</li>
'///+<li>&quot;Table&quot;</li>
'///+<li>&quot;Source&quot;</li>
'///+<li>&quot;Background&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "VIEW"
                              Kontext "TabInhalteHTML"
                              If TabInhalteHTML.exists then bCorPage = TRUE
                      case "FORMATTINGAIDS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabDirektCursor"
                              If TabDirektCursor.exists then bCorPage = TRUE
                      case "GRID"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabRaster"
                              If TabRaster.exists then bCorPage = TRUE
                      case "PRINT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabDruckenHTML"
                              If TabDruckenHTML.exists then bCorPage = TRUE
                      case "TABLE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 5 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabTabelleOptionen"
                              If TabTabelleOptionen.exists then bCorPage = TRUE
                      case "SOURCE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 6 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabQuelltext"
                              If TabQuelltext.exists then bCorPage = TRUE
                      case "BACKGROUND"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 7 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabHintergrund"
                              If TabHintergrund.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "SPREADSHEET"
'///Pages in group &quot;Spreadsheet&quot;are:
'///+<ul><li>&quot;General&quot;</li>
'///+<li>&quot;View&quot;</li>
'///+<li>&quot;Calculate&quot;</li>
'///+<li>&quot;Sortlists&quot;</li>
'///+<li>&quot;Changes&quot;</li>
'///+<li>&quot;Grid&quot;</li>
'///+<li>&quot;Print&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "GENERAL"
                              Kontext "TabLayoutCalc"
                              If TabLayoutCalc.exists then bCorPage = TRUE
                      case "VIEW"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabInhaltCalc"
                              If TabInhaltCalc.exists then bCorPage = TRUE
                      case "CALCULATE"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabBerechnen"
                              If TabBerechnen.exists then bCorPage = TRUE
                      case "SORTLISTS"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabSortierlisten"
                              If TabSortierlisten.exists then bCorPage = TRUE
                      case "CHANGES"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 5 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabAenderungenCalc"
                              If TabAenderungenCalc.exists then bCorPage = TRUE
                      case "GRID"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 6 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabRaster"
                              If TabRaster.exists then bCorPage = TRUE
                      case "PRINT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 7 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabPrintCalcOptions"
                              If TabPrintCalcOptions.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "PRESENTATION"
'///Pages in group &quot;Presentation&quot;are:
'///+<ul><li>&quot;General&quot;</li>
'///+<li>&quot;View&quot;</li>
'///+<li>&quot;Grid&quot;</li>
'///+<li>&quot;Print&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "GENERAL"
                              Kontext "TabSonstigesDraw"
                              If TabSonstigesDraw.exists then bCorPage = TRUE
                      case "VIEW"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabInhalteDraw"
                              If TabInhalteDraw.exists then bCorPage = TRUE
                      case "GRID"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabRaster"
                              If TabRaster.exists then bCorPage = TRUE
                      case "PRINT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabDruckenDraw"
                              If TabDruckenDraw.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "DRAWING"
'///Pages in group &quot;Drawing&quot;are:            
'///+<ul><li>&quot;General&quot;</li>
'///+<li>&quot;View&quot;</li>
'///+<li>&quot;Grid&quot;</li>
'///+<li>&quot;Print&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "GENERAL"
                              Kontext "TabSonstigesDraw"
                              If TabSonstigesDraw.exists then bCorPage = TRUE
                      case "VIEW"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 2 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabInhalteDraw"
                              If TabInhalteDraw.exists then bCorPage = TRUE
                      case "GRID"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 3 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabRaster"
                              If TabRaster.exists then bCorPage = TRUE
                      case "PRINT"
                              if bFirst = TRUE then Optionsliste.Select ( startpos + 4 )
                              sleep (1)
                              bFirst = FALSE
                              Kontext "TabDruckenDraw"
                              If TabDruckenDraw.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "FORMULA"
'///Page(s) in group &quot;Formula&quot;are:
'///+<ul><li>&quot;Settings&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "SETTINGS"
                              Kontext "TabDruckenMath"
                              If TabDruckenMath.exists then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "CHART"
'///Pages in group &quot;Diagramm&quot;are:
'///+<ul><li>&quot;DefaultColors&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "DEFAULTCOLORS"
                              Kontext "TabGrundfarben"
                              If TabGrundfarben.exists(4) then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case "DATASOURCES"
'///Pages in group &quot;Datasource&quot;are:            
'///+<ul><li>&quot;Connetions&quot;</li></ul>
                  select case ucase$(Tabpagename)
                      case "CONNECTIONS"
                              Kontext "TabConnections"
                              If TabConnections.exists(4) then bCorPage = TRUE
                      case else : bCorPage = FALSE
                  end select
            case else
                  bCorPage = False
         end select
         If bCorPage = TRUE then Exit for
      next i
      if bCorPage = FALSE then warnlog "hToolsOptions(): "+ Applicationname + " / " + Tabpagename + " could not be found! Please review your test!"
   else
      bCorPage = FALSE
      warnlog "Please open the option-dialog with 'ToolsOptions' before you called this routine!"
   end if
   hToolsOptions = bCorPage
end function

