'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: g_option.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:43 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : thorsten.bosbach@sun.com
'*
'* short description : update and resouce test for all option pages (at tools/options)
'*
'************************************************************************
'*
' #1  tToolsOptionsStarOffice
' #1  tToolsOptionsLoadSave
' #1  tToolsOptionsLanguageSettings
' #1  tToolsOptionsInternet
'*
'\***********************************************************************
global sErrMes as String
global iSectionNumber as Integer

'-------------------------------------------------------------------------

sub ExtrasOptionenTest
   Call tToolsOptionsTest
end sub

'-------------------------------------------------------------------------

sub tToolsOptionsTest
   sErrMes = ""
   iSectionNumber = 12
   ' subs and functions has been placed there
   use "global\tools\inc\t_option2.inc"
   ' common testcases are placed in this library
   Call tToolsOptionsStarOffice
   Call tToolsOptionsLoadSave
   Call tToolsOptionsLanguageSettings
   Call tToolsOptionsInternet
   ' Document- and database related options are placed in the g_option2.inc library 
   use "global\update\inc\g_option2.inc"   
   Call tToolsOptionsTextdocument
   Call tToolsOptionsHTMLDocument
   Call tToolsOptionsSpreadsheet
   Call tToolsOptionsPresentation
   Call tToolsOptionsDrawing
   Call tToolsOptionsFormula
   Call tToolsOptionsChart
   Call tToolsOptionsDataSources
end sub

'-------------------------------------------------------------------------

testcase tToolsOptionsStarOffice
  dim EchteAnzahl as Integer, i as Integer
  dim gefunden as Boolean, bSave as Boolean
  dim iMenuShould as integer
'/// usually we have 12 tabpages in this category, if the central configuration is used 13 (Single SignOn)///'
'///- tools/options/StarOffice
   PrintLog "- Tools/Options/StarOffice  ( Extras/Optionen/StarOffice )"
   if gApplication <> "DESKTOP" then Call hNewDocument
   ToolsOptions
   ToPosInOptionlist ( 1 )
   Kontext "ExtrasOptionenDlg"
   EchteAnzahl = Optionsliste.GetItemCount - iSectionNumber
   iMenuShould = 12
   if gCentralConfiguration then iMenuShould = iMenuShould + 1 ' Now we have the options page SingleSignOn
   if EchteAnzahl <> iMenuShould then
      Warnlog "The number of entries is not " + iMenuShould + "! => the current number is " + EchteAnzahl
   end if
   Kontext "Active"
   try
      if Active.Exists then Active.OK
   catch
      if Active.Exists then Active.No
   endcatch
   for i=1 to EchteAnzahl
      gefunden = FALSE
      Kontext "OptionenDlg"
      Optionsliste.TypeKeys "<Down>"
      select case i
       case 1 : Kontext "TabAllgemeines"
                '///+-    user data
                printlog "  - Userdata / Benutzerdaten"
                if TabAllgemeines.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabAllgemeines )
                end if
       case 2 : Kontext "TabSonstigesAllgemein"
                '///+-    general
                printlog "  - General / Allgemein"
                if TabSonstigesAllgemein.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSonstigesAllgemein )
                end if
       case 3 : Kontext "TabMemory"
                '///+-    memory
                printlog "  - Memory / Arbeitsspeicher"
                if TabMemory.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabMemory )
                end if
       case 4 : Kontext "TabAnsichtAllgemein"
                '///+-    view
                printlog "  - View / Ansicht"
                if TabAnsichtAllgemein.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabAnsichtAllgemein )
                end if
       case 5 : Kontext "TabPrintStarOffice"
                '///+-    Print
                printlog "  - Print / Drucken"
                if TabPrintStarOffice.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabPrintStarOffice )
                end if
       case 6 : Kontext "TabHelperPrograms"
                '///+-    helper programs ( on unix click on all open-buttons and close the file-dialog )
                printlog "  - Helper Programs / Hilfsprogramme"
                if TabHelperPrograms.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabHelperPrograms )
                   if gUseSysDlg <> TRUE then                                    ' only for non-system file-dialog
                      if gPlatgroup <> "unx" then
                         bSave = EMail.IsChecked                                 ' for all OS
                         EMail.UnCheck
                      end if
                      EMailOpen.Click
                       Kontext "OeffnenDlg"
                          Sleep (1)
                       OeffnenDlg.Cancel
                      Kontext "TabHelperPrograms"
                      if gPlatgroup = "unx" then                                 ' only for unix
                         HttpOpen.Click
                          Kontext "OeffnenDlg"
                          Sleep (1)
                          OeffnenDlg.Cancel
                          Sleep (2)
                         Kontext "TabHelperPrograms"
                         HttpsOpen.Click
                          Kontext "OeffnenDlg"
                          Sleep (1)
                          OeffnenDlg.Cancel
                          Sleep (2)
                         Kontext "TabHelperPrograms"
                         FTPOpen.Click
                          Kontext "OeffnenDlg"
                          Sleep (1)
                          OeffnenDlg.Cancel
                          Sleep (2)
                         Kontext "TabHelperPrograms"
                         MailToOpen.Click
                          Kontext "OeffnenDlg"
                          Sleep (1)
                          OeffnenDlg.Cancel
                          Sleep (2)
                         Kontext "TabHelperPrograms"
                         DocmanagerOpen.Click
                          Kontext "OeffnenDlg"
                          Sleep (1)
                          OeffnenDlg.Cancel
                          Sleep (2)
                         Kontext "TabHelperPrograms"
                      end if
                      if gPlatgroup <> "unx" then
                         if bSave = TRUE then EMail.Check else EMail.UnCheck
                      end if
                   end if
                end if
       case 7 : Kontext "TabPfade"
                '///+-    paths ( click edit for all list entries and close the filedialog )
                printlog "  - Paths / Pfade"
                if TabPfade.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabPfade )
                   Call DialogeFuerTypenKontrollieren
                end if
       case 8 : Kontext "TabFarben"
                '///+-    colors ( 'add' => click; 'Messagebox' => OK; 'Name dialog' => cancel;
                '///+-             'edit' => click; 'Colors dialog' => close; )
                printlog "  - Color / Farben"
                Sleep 4
                if TabFarben.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabFarben )
                   if gPlatgroup <> "unx" then
                      Farbe.Select 1
                      Hinzufuegen.Click
                        Kontext "Active"
                        Active.OK
                        Kontext "NameDlg"
                        Call DialogTest ( NameDlg )
                        NameDlg.Cancel
                      Kontext "TabFarben"
                      Bearbeiten.Click
                        Sleep 3
                        Kontext "FarbeDlg"
                        FarbeDlg.Cancel
                   else
                      printlog "BugID:96754 = Focus-problems on Gnome. I remark this test for UNIX"
                   end if
                end if
       case 9 : Kontext "TabSchriftErsetzung"
                '///+-    font replacement
                printlog "  - Font Replacement / Schriftersetzung"
                if TabSchriftErsetzung.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSchriftErsetzung )
                end if
       case 10: Kontext "TabSicherheit"
                '///+-    security
                printlog "  - Security / Sicherheit"
                if TabSicherheit.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSicherheit )
                end if
       case 11: Kontext "TabAppearance"
                '///+-    Appearance
                printlog "  - Appearance / Aussehen"
                if TabAppearance.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabAppearance )
                end if
       case 12: Kontext "TabAccessibility"
                '///+-    Accessibility
                printlog "  - Accessibility"
                if TabAccessibility.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabAccessibility )
                end if
       case 13: Kontext "TabSingleSignOn"
                '///+-    Single SignOn
                printlog "  - Single SignOn"
                if TabSingleSignOn.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSingleSignOn )
                end if
      end select
      if gefunden=FALSE then
         Warnlog "Error with the " + i + ".page, perhaps this page is deleted or change the place!"
         EchteAnzahl = EchteAnzahl - 1
         if EchteAnzahl < 12 then
            i=10
         else
            i=1-1
         end if
      end if
   next i
'///+- close the options dialog
   Kontext "OptionenDlg"
   OptionenDlg.Cancel
   if gApplication <> "DESKTOP" then Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tToolsOptionsLoadSave
  dim EchteAnzahl as Integer, i as Integer
  dim gefunden as Boolean
   PrintLog "- Tools/Options/Load Save  ( Extras/Optionen/Laden Speichern )"
   if gApplication <> "DESKTOP" then Call hNewDocument
'///- tools/options/load save
   ToolsOptions
   ToPosInOptionlist ( 2 )
   EchteAnzahl = OptionTabPageZaehler ( 4, FALSE )
   for i=1 to EchteAnzahl
      gefunden = FALSE
      Kontext "OptionenDlg"
      Optionsliste.TypeKeys "<Down>"
      select case i
       case 1 : Kontext "TabSpeichern"
                '///+-    general
                printlog "  - General / Save"
                if TabSpeichern.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSpeichern )
                end if
       case 2 : Kontext "TabMicrosoftOffice97"
                '///+-    VBA settings
                printlog "  - VBA Settings / VBA Eigenschaften"
                if TabMicrosoftOffice97.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabMicrosoftOffice97 )
                end if
       case 3 : Kontext "TabMicrosoftOffice2"
                '///+-    Microsoft Office
                printlog "  - Microsoft Office"
                if TabMicrosoftOffice2.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabMicrosoftOffice2 )
                end if
       case 4 : Kontext "TabHTML"
                '///+-    HTML compatibility
                printlog "  - HTML Compatibility / HTML Kompatibilitaet"
                if TabHTML.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabHTML )
                end if
      end select
      if gefunden=FALSE then
         Warnlog "Error with the " + i + ".page, perhaps this page is deleted or change the place!"
         EchteAnzahl = EchteAnzahl - 1
         if EchteAnzahl < 5 then
            i=11
         else
            i=1-1
         end if
      end if
   next i
'///+- close the options dialog
   Kontext "OptionenDlg"
   OptionenDlg.Cancel

   if gApplication <> "DESKTOP" then Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tToolsOptionsLanguageSettings
  dim EchteAnzahl as Integer, i as Integer, j as Integer
  dim gefunden as Boolean
  dim bAsianSup as Boolean
   PrintLog "- Tools/Options/Language Settings  ( Extras/Optionen/Spracheinstellungen )"
   if gApplication <> "DESKTOP" then Call hNewDocument
 '///- tools / options / language settings
   ToolsOptions
   ToPosInOptionlist ( 3 )
   EchteAnzahl = Optionsliste.GetItemCount - iSectionNumber
   ' usually we only have 2 pages in this section : 'Languages' and 'Writing Aids'
   ' - on asian languages we have 2 additional: 'Japanese Find' and 'Asian Layout'
   ' - on ctl languages there is only one more: 'Complex Text Layout'
   select case (EchteAnzahl)
      case 2: printlog "Asian or Complex Text Layout support is not activated ( on languages-page )!"
      case 3: printlog "Complex Text Layout support is activated ( on languages-page )!"
      case 4: printlog "Asian support is activated ( on languages-page )!"
      case else
         Warnlog "There are more than 4 pages!"
   end select
   Kontext "Active"
   try
      if Active.Exists then Active.OK
   catch
      if Active.Exists then Active.No
   endcatch
   for i=1 to EchteAnzahl
      gefunden = FALSE
      Kontext "OptionenDlg"
      Optionsliste.TypeKeys "<Down>"
      select case i
       case 1 : Kontext "TabSprachen"
                '///+-    languages
                printlog "  - Languages / Sprachen"
                if TabSprachen.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSprachen )
                end if
       case 2 : Kontext "TabLinguistik"
                '///+-    writing aids
                printlog "  - Writing Aids / Linguistik"
                if TabLinguistik.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabLinguistik )
                '///+-       'modules' edit -> close dialog
                   SprachmoduleBearbeiten.Click
                    Kontext "ModuleBearbeiten"
                    Call DialogTest ( ModuleBearbeiten )
                    ModuleBearbeiten.Close
                   Kontext "TabLinguistik"
                '///+-       'dictionaries' new -> close dialog
                   Neu.Click
                    Kontext "BenutzerwoerterbuchAnlegen"
                    Call DialogTest ( BenutzerwoerterbuchAnlegen )
                    BenutzerwoerterbuchAnlegen.Cancel
                '///+-       'dictionaries' edit -> close dialog
                   Kontext "TabLinguistik"
                   for j=1 to 5
                      if Bearbeiten.IsEnabled then
                         Bearbeiten.Click
                         j=6
                      else
                         Benutzerwoerterbuch.TypeKeys "<Down>"
                      end if
                   next j
                   Kontext "BenutzerwoerterbuchBearbeiten"
                   if BenutzerwoerterbuchBearbeiten.Exists then
                      Call DialogTest ( BenutzerwoerterbuchBearbeiten )
                      BenutzerwoerterbuchBearbeiten.Close
                   else
                        warnlog "Edit the 'user-defined dictionary' is not possible => Bug?"
                   end if
                '///+-       'options' ( 9, 10, 11 entry ) edit -> close dialog
                   Kontext "TabLinguistik"
                   Optionen.TypeKeys "<PageUp>", 3
                   Sleep 1
                   Optionen.TypeKeys "<Down>", 8
                   Sleep 1
                   OptionenBearbeiten.Click
                    Kontext "SilbentrennungOptionen"
                    Call DialogTest ( SilbentrennungOptionen )
                    SilbentrennungOptionen.Cancel
                   Kontext "TabLinguistik"
                   Optionen.TypeKeys "<Down>"
                   OptionenBearbeiten.Click
                    Kontext "SilbentrennungOptionen"
                    Call DialogTest ( SilbentrennungOptionen )
                    SilbentrennungOptionen.Cancel
                   Kontext "TabLinguistik"
                   Optionen.TypeKeys "<Down>"
                   OptionenBearbeiten.Click
                    Kontext "SilbentrennungOptionen"
                    Call DialogTest ( SilbentrennungOptionen )
                    SilbentrennungOptionen.Cancel
                end if
       case 3 : try
                   Kontext "TabJapaneseFind"
                   '///+-    japanese find
                   if TabJapaneseFind.IsVisible then
                      printlog "  - Japanese Find / Japanische Suche"
                      gefunden = TRUE
                      Call DialogTest ( TabJapaneseFind )
                   end if
                catch
                   Kontext "TabComplexTextLayout"
                   '///+-    Complex Text Layout
                   if TabComplexTextLayout.IsVisible then
                      printlog "  - Complex Text Layout"
                      gefunden = TRUE
                      Call DialogTest ( TabComplexTextLayout )
                   end if
                endcatch
       case 4 : Kontext "TabAsianLayoutOptions"
                '///+-    asian layout
                printlog "  - Asian Layout / Asiatisches Layout"
                if TabAsianLayoutOptions.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabAsianLayoutOptions )
                end if
      end select
      if gefunden=FALSE then
         Warnlog "Error with the " + i + ".page, perhaps this page is deleted or change the place!"
         EchteAnzahl = EchteAnzahl - 1
         if EchteAnzahl < 5 then
            i=5
         else
            i=1-1
         end if
      end if
   next i
'///+- close the options dialog
   Kontext "OptionenDlg"
   OptionenDlg.Cancel

   if gApplication <> "DESKTOP" then Call hCloseDocument

endcase

'-------------------------------------------------------------------------

testcase tToolsOptionsInternet
  dim EchteAnzahl as Integer, i as Integer
  dim gefunden as Boolean
   PrintLog "- Tools/Options/Internet  ( Extras/Optionen/Internet )"
   if gApplication <> "DESKTOP" then Call hNewDocument
 '///- tools / options / internet
   ToolsOptions
   ToPosInOptionlist ( 4 )
   EchteAnzahl = OptionTabPageZaehler ( 2, FALSE )
   for i=1 to EchteAnzahl
      gefunden = FALSE
      Kontext "OptionenDlg"
      Optionsliste.TypeKeys "<Down>"
      Kontext "ProxyWarnung"
      if ProxyWarnung.Exists then
         NichtMehrAnzeigen.Check
         ProxyWarnung.OK
      end if
      select case i
       case 1 : Kontext "TabProxyServer"
                '///+-    proxy
                printlog "  - Proxy / Proxy"
                if TabProxyServer.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabProxyServer )
                end if
       case 2 : Kontext "Active"
                '///+-    search
                printlog "  - Search / Suche"
                if Active.Exists then
                   sErrMes = Active.GetText
                   Warnlog "A messagebox exists => BUG  : " + sErrMes
                   Active.OK
                end if
                Kontext "TabSuche"
                if TabSuche.IsVisible then
                   gefunden = TRUE
                   Call DialogTest ( TabSuche )
                end if
      end select
      if gefunden=FALSE then
         Warnlog "Error with the " + i + ".page, perhaps this page is deleted or change the place!"
         EchteAnzahl = EchteAnzahl - 1
         if EchtAnzahl < 3 then
            i=11
         else
            i=1-1
         end if
      end if
   next i
'///+- close the options dialog
   Kontext "OptionenDlg"
   OptionenDlg.Cancel

   if gApplication <> "DESKTOP" then Call hCloseDocument
endcase

'-------------------------------------------------------------------------

