'*************************************************************************
'*
'*  $RCSfile: xmltool1.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:54:20 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : XML Tools
'*
'***************************************************************************************
'*
' #1 CreateWorkXMLExportDir
' #1 hEnablePrettyPrinting
' #1 hOpenFileAndIgnoreMacroWarning
'*
'\***********************************************************************************
sub CreateWorkXMLExportDir ( DirName as string )
'/*** <i>CreateWorkXMLExportDir</i> creates in the StarOffice/work-
'/*** +directory a directory. If the same name exists the content (files only)
'/*** +will be deleted.
 Dim OutputPath as string
 Dim Isliste(200) as string
 Dim i, BornToKill
 printlog "Checking work-dir & creating '" & gOfficePath & ConvertPath(DirName) & "'."
  if hDirectoryExists ( gOfficePath & ConvertPath(DirName) ) = TRUE then
    OutputPath = gOfficePath & ConvertPath(DirName)
    IsListe(0) = 0
    GetFileList ( OutputPath ,  "*", IsListe() )
    BornToKill = KillFileList ( IsListe() )
     for i = 1 to BornToKill
      warnlog IsListe(i) & " could not be deleted!"
     next i
   else
    app.mkDir( gOfficePath & ConvertPath(DirName))
  end if
end sub
'-------------------------------------------------------------------------
sub hEnablePrettyPrinting (OPTIONAL A)
'/*** <i>hEnablePrettyPrinting</i> enables the pretty printing (=better
'/*** +formated view) in XML file export. It takes >10 percent more time
'/*** +to save files!!! OPTIONAL parameter is used to DISABLE it.
 ToolsOptions
 Kontext "ExtrasOptionenDLG"
  call hToolsOptions("loadsave","general")
 Kontext "TabSpeichern"
   if IsMissing(A) then
    if NoPrettyPrinting.IsChecked = TRUE then
     NoPrettyPrinting.Uncheck
     sleep(1)
     printlog "- XML pretty printing enabled ( xmltool1.inc )"
    end if
   else
    if NoPrettyPrinting.IsChecked = FALSE then
     NoPrettyPrinting.Check
     sleep(1)
     printlog "- XML pretty printing disabled ( xmltool1.inc )"
    end if
  end if
 Kontext "ExtrasOptionenDLG"
  ExtrasOptionenDLG.OK
end sub
'-------------------------------------------------------------------------

function hOpenFileAndIgnoreMacroWarning ( DocName$, optional IgnoreW ) as Boolean
   Dim DieDatei as String
   Dim Dummy as Boolean
   Dim isMis as Boolean
   Dim i as integer
   DieDatei = ConvertPath ( DocName$ )

   isMis = FALSE

   Dummy = TRUE
   if hFileExists ( DieDatei ) = FALSE then
      warnlog "xmltool1.inc::hOpenFileAndIgnoreMacroWarning(): '" & DieDatei & "' does not exists!"
      Dummy = FALSE
   else
      if IsMissing ( IgnoreW ) = TRUE then
         isMis = TRUE
      end if

      FileOpen
      sleep (1)
      Kontext "OeffnenDlg"
      Dateiname.SetText DieDatei
      sleep (3)
      Oeffnen.Click
      sleep (3)
      for i = 1 to 3
       Kontext "Messagebox"
        if Messagebox.Exists(2) then
           if isMis = FALSE then
              printLog "xmltool1.inc::hOpenFileAndIgnoreMacroWarning() [" & i & ". msg box]: " & Messagebox.GetText
            else
              warnlog "xmltool1.inc::hOpenFileAndIgnoreMacroWarning() [" & i & ". msg box]: " & Messagebox.GetText
           end if
           try
             Messagebox.OK
            catch
             Messagebox.Yes
           endcatch
         else
          if i = 1 then
           warnlog "No message box opened while opening the document!"
          end if
        end if
      next i
      Kontext "OeffnenDlg"
       if OeffnenDlg.Exists(1) then
         OeffnenDlg.Cancel
         Dummy = FALSE
         warnlog "hOpenFileAndIgnoreMacroWarning (): The File-Open-Dialog is open!"
       end if
   end if

   if Dummy = TRUE then
      hOpenFileAndIgnoreMacroWarning = IsItLoaded
   else
      hOpenFileAndIgnoreMacroWarning = FALSE
   end if
end function

'-------------------------------------------------------------------------

